---
title: Using DTMF with WebRTC
slug: Web/API/WebRTC_API/Using_DTMF
tags:
  - API
  - DTMF
  - Example
  - Guide
  - Media
  - RTCDTMFSender
  - RTCPeerConnection
  - Touch-tone
  - WebRTC
  - WebRTC API
---
<div>{{APIRef("WebRTC")}}</div>

<p><span class="seoSummary">In order to more fully support audio/video conferencing, <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> supports sending {{Glossary("DTMF")}} to the remote peer on an {{domxref("RTCPeerConnection")}}. This article offers a brief high-level overview of how DTMF works over WebRTC, then provides a guide for everyday developers about how to send DTMF over an <code>RTCPeerConnection</code>. The DTMF system is often referred to as "touch tone," after an old trade name for the system.</span></p>

<p>WebRTC doesn't send DTMF codes as audio data. Instead, they're sent out-of-band, as RTP payloads. Note, however, that although it's possible to <em>send</em> DTMF using WebRTC, there is currently no way to detect or receive <em>incoming</em> DTMF. WebRTC currently ignores these payloads; this is because WebRTC's DTMF support is primarily intended for use with legacy telephone services that rely on DTMF tones to perform tasks such as:</p>

<ul>
	<li>Teleconferencing systems</li>
	<li>Menu systems</li>
	<li>Voicemail systems</li>
	<li>Entry of credit card or other payment information</li>
	<li>Passcode entry</li>
</ul>

<div class="note">
<p><strong>Note</strong>: While the DTMF is not sent to the remote peer as audio, browsers may choose to play the corresponding tone to the local user as part of their user experience, since users are typically used to hearing their phone play the tones audibly.</p>
</div>

<h2 id="Sending_DTMF_on_an_RTCPeerConnection">Sending DTMF on an RTCPeerConnection</h2>

<p>A given {{domxref("RTCPeerConnection")}} can have multiple media tracks sent or received on it. When you wish to transmit DTMF signals, you first need to decide which track to send them on, since DTMF is sent as a series of out-of-band payloads on the {{domxref("RTCRtpSender")}} responsible for transmitting that track's data to the other peer.</p>

<p>Once the track is selected, you can obtain from its <code>RTCRtpSender</code> the {{domxref("RTCDTMFSender")}} object you'll use for sending DTMF. From there, you can call {{domxref("RTCDTMFSender.insertDTMF()")}} to enqueue DTMF signals to be sent on the track to the other peer. The <code>RTCRtpSender</code> will then send the tones to the other peer as packets alongside the track's audio data.</p>

<p>Each time a tone is sent, the <code>RTCPeerConnection</code> receives a {{event("tonechange")}} event with a {{domxref("RTCDTMFToneChangeEvent.tone", "tone")}} property specifying which tone finished playing, which is an opportunity to update interface elements, for example. When the tone buffer is empty, indicating that all the tones have been sent, a <code>tonechange</code> event with its <code>tone</code> property set to "" (an empty string) is delivered to the connection object.</p>

<p>If you'd like to know more about how this works, read {{RFC(3550, "RTP: A Transport Protocol for Real-Time Applications")}} and {{RFC(4733, "RTP Payload for DTMF Digits, Telephony Tones, and Telephony Signals")}}. The details of how DTMF payloads are handled on RTP are beyond the scope of this article. Instead, we'll focus on how to use DTMF within the context of an {{domxref("RTCPeerConnection")}} by studying how an example works.</p>

<h2 id="Simple_example">Simple example</h2>

<p>This simple example constructs two {{domxref("RTCPeerConnection")}}s, establishes a connection between them, then waits for the user to click a "Dial" button. When the button is clicked, a DTMF string is sent over the connection using {{domxref("RTCDTMFSender.insertDTMF()")}}. Once the tones finish transmitting, the connection is closed.</p>

<div class="note">
<p><strong>Note</strong>: This example is obviously somewhat contrived, since normally the two <code>RTCPeerConnection</code> objects would exist on different devices, and signaling would be done over the network instead of it all being linked up inline as it is here.</p>
</div>

<h3 id="HTML">HTML</h3>

<p>The HTML for this example is very basic; there are only three elements of importance:</p>

<ul>
	<li>An {{HTMLElement("audio")}} element to play the audio received by the <code>RTCPeerConnection</code> being "called."</li>
	<li>A {{HTMLElement("button")}} element to trigger creating and connecting the two <code>RTCPeerConnection</code> objects, then sending the DTMF tones.</li>
	<li>A {{HTMLElement("div")}} to receive and display log text to show status information.</li>
</ul>

<pre class="brush: html notranslate">  &lt;p&gt;This example demonstrates the use of DTMF in WebRTC. Note that this
     example is "cheating" by generating both peers in one code stream,
     rather than having each be a truly separate entity.&lt;/p&gt;

  &lt;audio id="audio" autoplay controls&gt;&lt;/audio&gt;&lt;br/&gt;
  &lt;button name="dial" id="dial"&gt;Dial&lt;/button&gt;

  &lt;div class="log"&gt;&lt;/div&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<p>Let's take a look at the JavaScript code next. Keep in mind that the process of establishing the connection is somewhat contrived here; you normally don't build both ends of the connection in the same document.</p>

<h4 id="Global_variables">Global variables</h4>

<p>First, we establish global variables.</p>

<pre class="brush: js notranslate">let dialString = "12024561111";

let callerPC = null;
let receiverPC = null;
let dtmfSender = null;

let hasAddTrack = false;

let mediaConstraints = {
  audio: true,
  video: false
};

let offerOptions = {
  offerToReceiveAudio: 1,
  offerToReceiveVideo: 0
};

let dialButton = null;
let logElement = null;
</pre>

<p>These are, in order:</p>

<dl>
	<dt><code>dialString</code></dt>
	<dd>The DTMF string the caller will send when the "Dial" button is clicked.</dd>
	<dt><code>callerPC</code> and <code>receiverPC</code></dt>
	<dd>The {{domxref("RTCPeerConnection")}} objects representing the caller and the receiver, respectively. These will be initialized when the call starts up, in our <code>connectAndDial()</code> function, as shown in {{anch("Starting the connection process")}} below.</dd>
	<dt><code>dtmfSender</code></dt>
	<dd>The {{domxref("RTCDTMFSender")}} object for the connection. This will be obtained while setting up the connection, in the <code>gotStream()</code> function shown in {{anch("Adding the audio to the connection")}}.</dd>
	<dt><code>hasAddTrack</code></dt>
	<dd>Because some browsers have not yet implemented {{domxref("RTCPeerConnection.addTrack()")}}, therefore requiring the use of the obsolete {{domxref("RTCPeerConnection.addStream", "addStream()")}} method, we use this Boolean to determine whether or not the user agent supports <code>addTrack()</code>; if it doesn't, we'll fall back to <code>addStream()</code>. This gets figured out in <code>connectAndDial()</code>, as shown in {{anch("Starting the connection process")}}.</dd>
	<dt><code>mediaConstraints</code></dt>
	<dd>An object conforming to the {{domxref("MediaConstraints")}} dictionary specifying the constraints to use when starting the connection. We want an audio-only connection, so <code>video</code> is <code>false</code>, while <code>audio</code> is <code>true</code>.</dd>
	<dt><code>offerOptions</code></dt>
	<dd>An <code>RTCOfferOptions</code> object providing options to specify when calling {{domxref("RTCPeerConnection.createOffer()")}}. In this case, we state that we want to receive audio but not video.</dd>
	<dt><code>dialButton</code> and <code>logElement</code></dt>
	<dd>These variables will be used to store references to the dial button and the {{HTMLElement("div")}} into which logging information will be written. They'll get set up when the page is first loaded. See {{anch("Initialization")}} below.</dd>
</dl>

<h4 id="Initialization">Initialization</h4>

<p>When the page loads, we do some basic setup: we fetch references to the dial button and the log output box elements, and we use {{domxref("EventTarget.addEventListener", "addEventListener()")}} to add an event listener to the dial button so that clicking it calls the <code>connectAndDial()</code> function to begin the connection process.</p>

<pre class="brush: js notranslate">window.addEventListener("load", function() {
  logElement = document.querySelector(".log");
  dialButton = document.querySelector("#dial");

  dialButton.addEventListener("click", connectAndDial, false);
});
</pre>

<h4 id="Starting_the_connection_process">Starting the connection process</h4>

<p>When the dial button is clicked, <code>connectAndDial()</code> is called. This starts building the WebRTC connection in preparation for sending the DTMF codes.</p>

<pre class="brush: js notranslate">function connectAndDial() {
  callerPC = new RTCPeerConnection();

  hasAddTrack = (callerPC.addTrack !== undefined);

  callerPC.onicecandidate = handleCallerIceEvent;
  callerPC.onnegotiationneeded = handleCallerNegotiationNeeded;
  callerPC.oniceconnectionstatechange = handleCallerIceConnectionStateChange;
  callerPC.onsignalingstatechange = handleCallerSignalingStateChangeEvent;
  callerPC.onicegatheringstatechange = handleCallerGatheringStateChangeEvent;

  receiverPC = new RTCPeerConnection();
  receiverPC.onicecandidate = handleReceiverIceEvent;

  if (hasAddTrack) {
    receiverPC.ontrack = handleReceiverTrackEvent;
  } else {
    receiverPC.onaddstream = handleReceiverAddStreamEvent;
  }

  navigator.mediaDevices.getUserMedia(mediaConstraints)
  .then(gotStream)
  .catch(err =&gt; log(err.message));
}
</pre>

<p>After creating the <code>RTCPeerConnection</code> for the caller (<code>callerPC</code>), we look to see if it has an {{domxref("RTCPeerConnection.addTrack", "addTrack()")}} method. If it does, we set <code>hasAddTrack</code> to <code>true</code>; otherwise, we set it to <code>false</code>. This variable will let the example operate even on browsers not yet implementing the newer <code>addTrack()</code> method; we'll do so by falling back to the older {{domxref("RTCPeerConnection.addStream", "addStream()")}} method.</p>

<p>Next, the event handlers for the caller are established. We'll cover these in detail later.</p>

<p>Then a second <code>RTCPeerConnection</code>, this one representing the receiving end of the call, is created and stored in <code>receiverPC</code>; its <code>onicecandidate</code> event handler is set up too.</p>

<p>If <code>addTrack()</code> is supported, we set up the receiver's <code>ontrack</code> event handler; otherwise, we set up <code>onaddstream</code>. The {{event("track")}} and {{event("addstream")}} events are sent when media is added to the connection.</p>

<p>Finally, we call {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} to obtain access to the caller's microphone. If successful, the function <code>gotStream()</code> is called, otherwise we log the error because calling has failed.</p>

<h4 id="Adding_the_audio_to_the_connection">Adding the audio to the connection</h4>

<p>As mentioned above, when the audio input from the microphone is obtained, <code>gotStream()</code> is called. Its job is to build the stream being sent to the receiver, so the actual process of starting to transmit can begin. It also gets access to the <code>RTCDTMFSender</code> we'll use to issue DTMF on the connection.</p>

<pre class="brush: js notranslate">function gotStream(stream) {
  log("Got access to the microphone.");

  let audioTracks = stream.getAudioTracks();

  if (hasAddTrack) {
    if (audioTracks.length &gt; 0) {
      audioTracks.forEach(track =&gt; callerPC.addTrack(track, stream));
    }
  } else {
    log("Your browser doesn't support RTCPeerConnection.addTrack(). Falling " +
        "back to the &lt;strong&gt;deprecated&lt;/strong&gt; addStream() method...");
    callerPC.addStream(stream);
  }

  if (callerPC.getSenders) {
    dtmfSender = callerPC.getSenders()[0].dtmf;
  } else {
    log("Your browser doesn't support RTCPeerConnection.getSenders(), so " +
        "falling back to use &lt;strong&gt;deprecated&lt;/strong&gt; createDTMFSender() " +
        "instead.");
    dtmfSender = callerPC.createDTMFSender(audioTracks[0]);
  }

  dtmfSender.ontonechange = handleToneChangeEvent;
}
</pre>

<p>After setting <code>audioTracks</code> to be a list of the audio tracks on the stream from the user's microphone, it's time to add the media to the caller's <code>RTCPeerConnection</code>. If <code>addTrack()</code> is available on the <code>RTCPeerConnection</code>, we add each of the stream's audio tracks, one by one, to the connection using {{domxref("RTCPeerConnection.addTrack()")}}. Otherwise we call {{domxref("RTCPeerConnection.addStream()")}} to add the stream to the call as a single unit.</p>

<p>Next we look to see if the {{domxref("RTCPeerConnection.getSenders()")}} method is implemented. If it is, we call it on <code>callerPC</code> and get the first entry in the returned list of senders; this is the {{domxref("RTCRtpSender")}} responsible for transmitting data for the first audio track on the call (which is the track we'll send DTMF over). We then obtain the <code>RTCRtpSender</code>'s {{domxref("RTCRtpSender.dtmf", "dtmf")}} property, which is an {{domxref("RTCDTMFSender")}} object that can send DTMF on the connection, from the caller to the receiver.</p>

<p>If <code>getSenders()</code> isn't available, we instead call {{domxref("RTCPeerConnection.createDTMFSender()")}} to get the <code>RTCDTMFSender</code> object. Although this method is obsolete, this example supports it as a fallback to let older browsers (and those not yet updated to support the current WebRTC DTMF API) run the example.</p>

<p>Finally, we set the DTMF sender's {{domxref("RTCDTMFSender.ontonechange", "ontonechange")}} event handler so we get notified each time a DTMF tone finishes playing.</p>

<p>You can find the log function at the bottom of the documentation.</p>

<h4 id="When_a_tone_finishes_playing">When a tone finishes playing</h4>

<p>Each time a DTMF tone finishes playing, a {{event("tonechange")}} event is delivered to <code>callerPC</code>. The event listener for these is implemented as the <code>handleToneChangeEvent()</code> function.</p>

<pre class="brush: js notranslate">function handleToneChangeEvent(event) {
  if (event.tone !== "") {
    log("Tone played: " + event.tone);
  } else {
    log("All tones have played. Disconnecting.");
    callerPC.getLocalStreams().forEach(function(stream) {
      stream.getTracks().forEach(function(track) {
        track.stop();
      });
    });
    receiverPC.getLocalStreams().forEach(function(stream) {
      stream.getTracks().forEach(function(track) {
        track.stop();
      });
    });

    audio.pause();
    audio.srcObject = null;
    receiverPC.close();
    callerPC.close();
  }
}
</pre>

<p>The {{event("tonechange")}} event is used both to indicate when an individual tone has played and when all tones have finished playing. The event's {{domxref("RTCDTMFToneChangeEvent.tone", "tone")}} property is a string indicating which tone just finished playing. If all tones have finished playing, <code>tone</code> is an empty string; when that's the case, {{domxref("RTCDTMFSender.toneBuffer")}} is empty.</p>

<p>In this example, we log to the screen which tone just finished playing. In a more advanced application, you might update the user interface, for example, to indicate which note is currently playing.</p>

<p>On the other hand, if the tone buffer is empty, our example is designed to disconnect the call. This is done by stopping each stream on both the caller and the receiver by iterating over each <code>RTCPeerConnection</code>'s track list (as returned by its {{domxref("RTCPeerConnection.getTracks", "getTracks()")}} method) and calling each track's {{domxref("MediaStreamTrack.stop", "stop()")}} method.</p>

<p>Once both the caller's and the receiver's media tracks are all stopped, we pause the {{HTMLElement("audio")}} element and set its {{domxref("HTMLMediaElement.srcObject", "srcObject")}} to <code>null</code>. This detaches the audio stream from the {{HTMLElement("audio")}} element.</p>

<p>Then, finally, each <code>RTCPeerConnection</code> is closed by calling its {{domxref("RTCPeerConnection.close", "close()")}} method.</p>

<h4 id="Adding_candidates_to_the_caller">Adding candidates to the caller</h4>

<p>When the caller's <code>RTCPeerConnection</code> ICE layer comes up with a new candidate to propose, it issues an {{event("icecandidate")}} event to <code>callerPC</code>. The <code>icecandidate</code> event handler's job is to transmit the candidate to the receiver. In our example, we are directly controlling both the caller and the receiver, so we can just directly add the candidate to the receiver by calling its {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} method. That's handled by <code>handleCallerIceEvent()</code>:</p>

<pre class="brush: js notranslate">function handleCallerIceEvent(event) {
  if (event.candidate) {
    log("Adding candidate to receiver: " + event.candidate.candidate);

    receiverPC.addIceCandidate(new RTCIceCandidate(event.candidate))
    .catch(err =&gt; log("Error adding candidate to receiver: " + err));
  } else {
    log("Caller is out of candidates.");
  }
}
</pre>

<p>If the {{event("icecandidate")}} event has a non-<code>null</code> <code>candidate</code> property, we create a new {{domxref("RTCIceCandidate")}} object from the <code>event.candidate</code> string and "transmit" it to the receiver by calling <code>receiverPC.addIceCandidate()</code>, providing the new <code>RTCIceCandidate</code> as its input. If <code>addIceCandidate()</code> fails, the <code>catch()</code> clause outputs the error to our log box.</p>

<p>If <code>event.candidate</code> is <code>null</code>, that indicates that there are no more candidates available, and we log that information.</p>

<h4 id="Dialing_once_the_connection_is_open">Dialing once the connection is open</h4>

<p>Our design requires that when the connection is established, we immediately send the DTMF string. To accomplish that, we watch for the caller to receive an {{event("iceconnectionstatechange")}} event. This event is sent when one of a number of changes occurs to the state of the ICE connection process, including the successful establishment of a connection.</p>

<pre class="brush: js notranslate">function handleCallerIceConnectionStateChange() {
  log("Caller's connection state changed to " + callerPC.iceConnectionState);
  if (callerPC.iceConnectionState === "connected") {
    log("Sending DTMF: \"" + dialString + "\"");
    dtmfSender.insertDTMF(dialString, 400, 50);
  }
}
</pre>

<p>The <code>iceconnectionstatechange</code> event doesn't actually include within it the new state, so we get the connection process's current state from <code>callerPC</code>'s {{domxref("RTCPeerConnection.iceConnectionState")}} property. After logging the new state, we look to see if the state is <code>"connected"</code>. If so, we log the fact that we're about to send the DTMF, then we call {{domxref("RTCDTMFSender.insertDTMF", "dtmf.insertDTMF()")}} to send the DTMF on the same track as the audio data method on the <code>RTCDTMFSender</code> object we {{anch("Adding the audio to the connection", "previously stored")}} in <code>dtmfSender</code>.</p>

<p>Our call to <code>insertDTMF()</code> specifies not only the DTMF to send (<code>dialString</code>), but also the length of each tone in milliseconds (400 ms) and the amount of time between tones (50 ms).</p>

<h4 id="Negotiating_the_connection">Negotiating the connection</h4>

<p>When the calling {{domxref("RTCPeerConnection")}} begins to receive media (after the microphone's stream is added to it), a {{event("negotiationneeded")}} event is delivered to the caller, letting it know that it's time to start negotiating the connection with the receiver. As previously mentioned, our example is simplified somewhat because we control both the caller and the receiver, so <code>handleCallerNegotiationNeeded()</code> is able to quickly construct the connection by chaining the required calls together for both the caller and receiver, as shown below.</p>

<pre class="brush: js notranslate">function handleCallerNegotiationNeeded() {
  log("Negotiating...");
  callerPC.createOffer(offerOptions)
  .then(function(offer) {
    log("Setting caller's local description: " + offer.sdp);
    return callerPC.setLocalDescription(offer);
  })
  .then(function() {
    log("Setting receiver's remote description to the same as caller's local");
    return receiverPC.setRemoteDescription(callerPC.localDescription)
  })
  .then(function() {
    log("Creating answer");
    return receiverPC.createAnswer();
  })
  .then(function(answer) {
    log("Setting receiver's local description to " + answer.sdp);
    return receiverPC.setLocalDescription(answer);
  })
  .then(function() {
    log("Setting caller's remote description to match");
    return callerPC.setRemoteDescription(receiverPC.localDescription);
  })
  .catch(err =&gt; log("Error during negotiation: " + err.message));
}
</pre>

<p>Since the various methods involved in negotiating the connection return {{jsxref("promise")}}s, we can chain them together like this:</p>

<ol>
	<li>Call {{domxref("RTCPeerConnection.createOffer", "callerPC.createOffer()")}} to get an offer.</li>
	<li>Then take that offer and set the caller's local description to match by calling {{domxref("RTCPeerConnection.setLocalDescription", "callerPC.setLocalDescription()")}}.</li>
	<li>Then "transmit" the offer to the receiver by calling {{domxref("RTCPeerConnection.setRemoteDescription", "receiverPC.setRemoteDescription()")}}. This configures the receiver so that it knows how the caller is configured.</li>
	<li>Then the receiver creates an answer by calling {{domxref("RTCPeerConnection.createAnswer", "receiverPC.createAnswer()")}}.</li>
	<li>Then the receiver sets its local description to match the newly-created answer by calling {{domxref("RTCPeerConnection.setLocalDescription", "receiverPC.setLocalDescription()")}}.</li>
	<li>Then the answer is "transmitted" to the caller by calling {{domxref("RTCPeerConnection.setRemoteDescription", "callerPC.setRemoteDescription()")}}. This lets the caller know what the receiver's configuration is.</li>
	<li>If at any time an error occurs, the <code>catch()</code> clause outputs an error message to the log.</li>
</ol>

<h4 id="Tracking_other_state_changes">Tracking other state changes</h4>

<p>We can also watch for changes to the signaling state (by accepting {{event("signalingstatechange")}} events) and the ICE gathering state (by accepting {{event("icegatheringstatechange")}} events). We aren't using these for anything, so all we do is log them. We could have not set up these event listeners at all.</p>

<pre class="brush: js notranslate">function handleCallerSignalingStateChangeEvent() {
  log("Caller's signaling state changed to " + callerPC.signalingState);
}

function handleCallerGatheringStateChangeEvent() {
  log("Caller's ICE gathering state changed to " + callerPC.iceGatheringState);
}
</pre>

<h4 id="Adding_candidates_to_the_receiver">Adding candidates to the receiver</h4>

<p>When the receiver's <code>RTCPeerConnection</code> ICE layer comes up with a new candidate to propose, it issues an {{event("icecandidate")}} event to <code>receiverPC</code>. The <code>icecandidate</code> event handler's job is to transmit the candidate to the caller. In our example, we are directly controlling both the caller and the receiver, so we can just directly add the candidate to the caller by calling its {{domxref("RTCPeerConnection.addIceCandidate", "addIceCandidate()")}} method. That's handled by <code>handleReceiverIceEvent()</code>.</p>

<p>This code is analogous to the <code>icecandidate</code> event handler for the caller, seen in {{anch("Adding candidates to the caller")}} above.</p>

<pre class="brush: js notranslate">function handleReceiverIceEvent(event) {
  if (event.candidate) {
    log("Adding candidate to caller: " + event.candidate.candidate);

    callerPC.addIceCandidate(new RTCIceCandidate(event.candidate))
    .catch(err =&gt; log("Error adding candidate to caller: " + err));
  } else {
    log("Receiver is out of candidates.");
  }
}
</pre>

<p>If the {{event("icecandidate")}} event has a non-<code>null</code> <code>candidate</code> property, we create a new {{domxref("RTCIceCandidate")}} object from the <code>event.candidate</code> string and deliver it to the caller by passing that into <code>callerPC.addIceCandidate()</code>. If <code>addIceCandidate()</code> fails, the <code>catch()</code> clause outputs the error to our log box.</p>

<p>If <code>event.candidate</code> is <code>null</code>, that indicates that there are no more candidates available, and we log that information.</p>

<h4 id="Adding_media_to_the_receiver">Adding media to the receiver</h4>

<p>When the receiver begins to receive media, an event is delivered to the receiver's {{domxref("RTCPeerConnection")}}, <code>receiverPC</code>. As explained in {{anch("Starting the connection process")}}, the current WebRTC specification uses the {{event("track")}} event for this, but some browsers haven't been updated to support this yet, so we also need to handle the {{event("addstream")}} event. The <code>handleReceiverTrackEvent()</code> and <code>handleReceiverAddStreamEvent()</code> methods, shown below, handle these.</p>

<pre class="brush: js notranslate">function handleReceiverTrackEvent(event) {
  audio.srcObject = event.streams[0];
}

function handleReceiverAddStreamEvent(event) {
  audio.srcObject = event.stream;
}
</pre>

<p>The <code>track</code> event includes a {{domxref("RTCTrackEvent.streams", "streams")}} property containing an array of the streams the track is a member of (one track can be part of many streams). We take the first stream and attach it to the {{HTMLElement("audio")}} element.</p>

<p>The <code>addstream</code> event includes a {{domxref("RTCTrackEvent.stream", "stream")}} property specifying a single stream added to the track. We attach it to the <code>&lt;audio&gt;</code> element.</p>

<h4 id="Logging">Logging</h4>

<p>A simple <code>log()</code> function is used throughout the code to append HTML to a {{HTMLElement("div")}} box for displaying status and errors to the user.</p>

<pre class="brush: js notranslate">function log(msg) {
  logElement.innerHTML += msg + "&lt;br/&gt;";
}</pre>

<h3 id="Result">Result</h3>

<p>You can try this example here. When you click the "Dial" button, you should see a series of logging messages output, then the dialing will begin. If your browser plays the tones audibly as part of its user experience, you should hear them as they're transmitted.</p>

<p>{{ EmbedLiveSample('Simple_example', 600, 500, "", "", "", "microphone") }}</p>

<p>Once transmission of the tones is complete, the connection is closed. You can click "Dial" again to reconnect and send the tones again.</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a> (a tutorial and example which explains the signaling process in more detail)</li>
	<li><a href="/en-US/docs/Web/API/WebRTC_API/Protocols">Introduction to WebRTC protocols</a></li>
</ul>
